Subject: Re: Device tree and IRQ for chip on PCI

From: Matthias Fuchs <[email-masked]>
Date: Tue, 18 Nov 2008 06:49:28 +0100

Hi Matteo,

> I have a chip connected on the PCI bus on an MPC512x, but if I get the
> IRQ property from the PCI chip, it is not set up by Linux.
It's not clear to me what you mean by this. 
Do you see an interrupt assigned to your pci device's PCI_INTERRUPT_LINE 
register? Check lspci output.

> The IRQ line goes directly from the chip to the MPC512x uc, so I don't
> know if I should create a separate node just to get the interrupt, or I
No. The pci node in  the DT should be ok.
Because you posted to an embedded list, I need to ask this: are you using a 
custom hardware? Does the DT fit to your board's interrupt / IDSEL routing?

Matthias

> should expect the pci functions to assign it an interrupt based on the
> PCI bus.
>
> The description for the PCI bus is like this:
>         pci: pci@80008500 {
>                 interrupt-map-mask = <0xf800 0x0 0x0 0x7>;
>                 interrupt-map = <
>                                 // IDSEL 0x15 - Slot PCI
>                                  0xa800 0x0 0x0 0x1 &ipic 0x0 0x8
>                                  0xa800 0x0 0x0 0x2 &ipic 0x1 0x8
>                                  0xa800 0x0 0x0 0x3 &ipic 0x2 0x8
>                                  0xa800 0x0 0x0 0x4 &ipic 0x3 0x8
>
>                                 >;
>
>                 interrupt-parent = < &ipic >;
>                 interrupts = <17 0x8>;
>                 bus-range = <0 0>;
>                 ranges = <0x42000000 0x0 0xa0000000 0xa0000000 0x0
> 0x10000000
>                           0x02000000 0x0 0xb0000000 0xb0000000 0x0
> 0x10000000
>                           0x01000000 0x0 0x00000000 0x84000000 0x0
> 0x01000000>;
>                 clock-frequency = <66000000>;
>                 #interrupt-cells = <1>;
>                 #size-cells = <2>;
>                 #address-cells = <3>;
>                 reg = <0x80008500 0x100>;
>                 compatible = "fsl,mpc5121-pci";
>                 device_type = "pci";
>         };